<template>
    <div class="bg-base-200 p-6 rounded-lg">
        <h1>
            Select the pictures you want to convert
        </h1>
        <div class="description text-sm mt-2">
            Here you can try to convert almost any picture format to webp
        </div>
        <div class="divider"></div>
        <div class="action__wrapper flex max-sm:flex-col justify-between">
            <input type="file" class="file-input w-full max-w-xs" multiple accept="image/jpeg,image/jpg,image/png" @change="setFilesHandler"/>
            <transition>
                <button class="btn btn-outline btn-success" @click="downloadAllHandler" v-if="isDownloadAll">Download all</button>
            </transition>
        </div>
        <div class="divider"></div>
        <div class="convert-result__wrapper grid grid-cols-4 gap-4" ref="previewWrapper">
        </div>
    </div>
</template>
<script setup lang="ts">
import { useConvert } from '@/hooks/useConverter';
import { ref } from 'vue';

const filesToConvert = ref<FileList>();
const previewWrapper = ref<HTMLElement | null>(null);
const isDownloadAll = ref(false);

const setFilesHandler = (event: Event) => {
    const target = event.target as HTMLInputElement;
    filesToConvert.value = target.files as FileList;

    if (filesToConvert.value.length > 1) {
        isDownloadAll.value = true;
    }

    const converter = new useConvert(filesToConvert.value, previewWrapper.value);

    converter.convertHandler()
    .finally(() => {
        console.log(useConvert.ImageUUIDList)
        filesToConvert.value = undefined;
    })
}

const downloadAllHandler = () => {
    isDownloadAll.value = false;
    useConvert.downloadAllHandler();
}
</script>
<style scoped>
.convert-result__wrapper > div {
  box-sizing: border-box;
  height: 240px;
  width: 240px;
  padding: 20px;
  display: inline-flex;
  justify-content: center;
  align-items: center;
  vertical-align: top;
}

img {
  max-height: 100%;
  max-width: 100%;
  box-shadow: 0px 0px 25px 0px rgba(0,0,0,0.75);
}
</style>
